// Copyright (C) 2000-2005, Luca Padovani <luca.padovani@cs.unibo.it>.
//
// This file is part of GtkMathView, a Gtk widget for MathML.
// 
// GtkMathView is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// GtkMathView is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GtkMathView; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// For details, see the GtkMathView World-Wide-Web page,
// http://helm.cs.unibo.it/mml-widget/, or send a mail to
// <lpadovan@cs.unibo.it>

#ifndef __TFMComputerModernMathGraphicDevice_hh__
#define __TFMComputerModernMathGraphicDevice_hh__

#include "MathGraphicDevice.hh"
#include "ComputerModernFamily.hh"

class GMV_MathView_EXPORT TFMComputerModernMathGraphicDevice : public MathGraphicDevice
{
protected:
  TFMComputerModernMathGraphicDevice(const SmartPtr<class AbstractLogger>&);
  virtual ~TFMComputerModernMathGraphicDevice();

public:
  void setFamily(const SmartPtr<class ComputerModernFamily>&);
  void setTFMManager(const SmartPtr<class TFMManager>&);

  static SmartPtr<TFMComputerModernMathGraphicDevice> create(const SmartPtr<class AbstractLogger>&);

  virtual scaled em(const class FormattingContext&) const;
  virtual scaled ex(const class FormattingContext&) const;
  virtual scaled defaultLineThickness(const class FormattingContext&) const;
  virtual scaled axis(const class FormattingContext&) const;
  virtual AreaRef glyph(const class FormattingContext&,
			const String&, const String&,
			unsigned long) const;

protected:
  SmartPtr<class TFM> getTFM(const class FormattingContext&, ComputerModernFamily::FontEncId) const;

private:
  SmartPtr<class ComputerModernFamily> family;
  SmartPtr<class TFMManager> tfmManager;
};

#endif // __TFMComputerModernMathGraphicDevice_hh__
